-------------------------------------------------------------------------------
-- Title      : test du tp picoblaze
-- Project    : 
-------------------------------------------------------------------------------
-- File       : test_topdesign.vhd
-- Author     :   http://vhdl33.free.fr
-- Company    : 
-- Last update: 2008/11/13
-- Platform   : 
-------------------------------------------------------------------------------
-- Description: 
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2006/09/05  1.0      nouel	Created
-------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY test_topdesign IS
  
END test_topdesign;


ARCHITECTURE simple OF test_topdesign IS

  COMPONENT topdesign
     PORT (   lcd_rs : OUT  std_ulogic;  -- command 0; data 1
              lcd_rw : OUT  std_ulogic;  -- read 1; write 0
              lcd_e : OUT  std_ulogic;  -- enable
              lcd : INOUT std_logic_vector(3 DOWNTO 0);  -- lcd en lecture/ecriture
              strataflash_oe : OUT std_ulogic;  -- signaux flash
              strataflash_we : OUT std_ulogic;  -- en paralelle
              strataflash_ce : OUT std_ulogic;  -- sur lcd
              reset : IN std_logic;     -- bouton reset
              clk : IN std_logic);      -- Horloge carte 50 MHz
  END COMPONENT;

  SIGNAL lcd_rs, lcd_rw, lcd_e : std_ulogic;
  SIGNAL lcd : std_logic_vector(3 DOWNTO 0);
  SIGNAL reset, clk : std_ulogic;

  CONSTANT periode : time := 20 ns;     -- 50 MHz

BEGIN  -- simple

 t1 : topdesign PORT MAP (
   lcd_rs         => lcd_rs,
   lcd_rw         => lcd_rw,
   lcd_e          => lcd_e,
   lcd            => lcd,
   strataflash_oe => OPEN,
   strataflash_we => OPEN,
   strataflash_ce => OPEN,
   reset          => reset,
   clk            => clk);

 reset <= '1', '0' AFTER periode + 5 ns;

 horloge: PROCESS
 BEGIN  -- PROCESS
   clk <= '1', '0' AFTER periode/2;
   WAIT FOR periode;
 END PROCESS;

END simple;
