-------------------------------------------------------------------------------
-- Title      : Description structurelle de ROM 128X8 XILINX
-- Project    : 
-------------------------------------------------------------------------------
-- File       : rom128x8_prim.vhd
-- Author     :   <nouel@AINHOA>
-- Company    : 
-- Last update: 2006/10/13
-- Platform   : 
-------------------------------------------------------------------------------
-- Description: 
-------------------------------------------------------------------------------
-- Revisions  :
-- Date        Version  Author  Description
-- 2006/10/11  1.0      nouel	Created
-------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
LIBRARY unisim;
USE unisim.vcomponents.ALL;

ENTITY rom128x8_prim IS  
  PORT (
    adresse : IN std_logic_vector(6 DOWNTO 0); 
    donnee  : OUT std_logic_vector(7 DOWNTO 0));
END rom128x8_prim;


ARCHITECTURE structurelle OF rom128x8_prim IS


  
  TYPE t_bitvec IS ARRAY (0 TO 7) OF bit_vector(127 DOWNTO 0);
  CONSTANT init_rom : t_bitvec := (
    X"0000000000000000074DC8CE4BA91F32",
    X"0000000000000000060125292AD0235F",
    X"00000000000000000294298149EE7E36",
    X"00000000000000000314854428B62E1E",
    X"0000000000000000040120090B504060",
    X"0000000000000000079FF9FFCFFFFE7E",
    X"000000000000000007DDEDEF63DF7F7F",
    X"00000000000000000000000000000000");

BEGIN  -- structurelle


  implant: FOR i IN 0 TO 7 GENERATE
    rx: ROM128x1
      GENERIC MAP (
        INIT =>init_rom(i))
      PORT MAP (
        o  => donnee(i),
        A0 => adresse(0),
        A1 => adresse(1),
        A2 => adresse(2),
        A3 => adresse(3),
        A4 => adresse(4),
        A5 => adresse(5),
        A6 => adresse(6));
  END GENERATE implant;
  

END structurelle;
